/*
 * 分账记录
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class ProfitReceiveRecordController : BaseController
    {
        public ProfitReceiveRecordController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
        }

        #region 分账记录列表

        /// <summary>
        /// 根据条件查询分账记录列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(ProfitReceiveRecord data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            
            return View();
        }

        #endregion

        #region 根据条件查询分账记录列表

        /// <summary>
        /// 分账记录列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(ProfitReceiveRecord data, string TypeSelect, string RelationTypeSelect, string StateSelect, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("CreateDate", "3"); //时间
Fields.Add("SubMchid", "1"); //子商户号
Fields.Add("AppId", "1"); //应用ID
Fields.Add("SubAppId", "1"); //子商户应用ID
Fields.Add("Account", "1"); //分账接收方账号
Fields.Add("TransactionId", "1"); //微信订单号
Fields.Add("OutOrderNo", "1"); //商户分账单号
Fields.Add("OrderId", "1"); //微信分账单号


            string condition = " and Status>-1";
            //分账接收方类型
if (!string.IsNullOrEmpty(TypeSelect))
{
condition += " and Type=" + TypeSelect;
}
//与分账方的关系类型
if (!string.IsNullOrEmpty(RelationTypeSelect))
{
condition += " and RelationType=" + RelationTypeSelect;
}
//分账单状态
if (!string.IsNullOrEmpty(StateSelect))
{
condition += " and State=" + StateSelect;
}


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ProfitReceiveRecord", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //分账接收方类型
string Type = dic["Type"].ToString();
if(Type == "MERCHANT_ID") dic["Type"] = "商户ID";
if(Type == "PERSONAL_OPENID") dic["Type"] = "个人openid";
if(Type == "PERSONAL_SUB_OPENID") dic["Type"] = "个人sub_openid";
if(Type == "") dic["Type"] = "";
//与分账方的关系类型
string RelationType = dic["RelationType"].ToString();
if(RelationType == "SERVICE_PROVIDER") dic["RelationType"] = "服务商";
if(RelationType == "STORE") dic["RelationType"] = "门店";
if(RelationType == "STAFF") dic["RelationType"] = "员工";
if(RelationType == "STORE_OWNER") dic["RelationType"] = "店主";
if(RelationType == "PARTNER") dic["RelationType"] = "合作伙伴";
if(RelationType == "HEADQUARTER") dic["RelationType"] = "总部";
if(RelationType == "BRAND") dic["RelationType"] = "品牌方";
if(RelationType == "DISTRIBUTOR") dic["RelationType"] = "分销商";
if(RelationType == "USER") dic["RelationType"] = "用户";
if(RelationType == "SUPPLIER") dic["RelationType"] = "供应商";
if(RelationType == "CUSTOM") dic["RelationType"] = "自定义";
if(RelationType == "") dic["RelationType"] = "";
dic["UnfreezeUnsplitName"] = dic["UnfreezeUnsplit"].ToString() == "1" ? "是" : "否";
//分账单状态
string State = dic["State"].ToString();
if(State == "PROCESSING") dic["State"] = "处理中";
if(State == "FINISHED") dic["State"] = "分账完成";
if(State == "") dic["State"] = "";

            }
            return Json(obj);
        }

        #endregion

        #region 增加分账记录

        /// <summary>
        /// 增加或修改分账记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加分账记录

        /// <summary>
        /// 增加或修改分账记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(ProfitReceiveRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("MerchantId", data.MerchantId); //商户
Fields.Add("SubMchid", data.SubMchid); //子商户号
Fields.Add("AppId", data.AppId); //应用ID
Fields.Add("SubAppId", data.SubAppId); //子商户应用ID
Fields.Add("Type", data.Type); //分账接收方类型
Fields.Add("Account", data.Account); //分账接收方账号
Fields.Add("Name", data.Name); //分账个人接收方姓名
Fields.Add("RelationType", data.RelationType); //与分账方的关系类型
Fields.Add("CustomRelation", data.CustomRelation); //自定义的分账关系
Fields.Add("TransactionId", data.TransactionId); //微信订单号
Fields.Add("OutOrderNo", data.OutOrderNo); //商户分账单号
Fields.Add("Amount", data.Amount); //分账金额
Fields.Add("Description", data.Description); //分账描述
Fields.Add("UnfreezeUnsplit", data.UnfreezeUnsplit); //是否解冻剩余未分资金

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Add("ProfitReceiveRecord", Fields, 0);
            AddSysLog(data.Id.ToString(), "ProfitReceiveRecord", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改分账记录

        /// <summary>
        /// 增加或修改分账记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            ProfitReceiveRecord editData = db.ProfitReceiveRecord.FirstOrDefault(m => m.Id == Id) ?? new ProfitReceiveRecord();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改分账记录

        /// <summary>
        /// 增加或修改分账记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(ProfitReceiveRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("MerchantId", data.MerchantId); //商户
Fields.Add("SubMchid", data.SubMchid); //子商户号
Fields.Add("AppId", data.AppId); //应用ID
Fields.Add("SubAppId", data.SubAppId); //子商户应用ID
Fields.Add("Type", data.Type); //分账接收方类型
Fields.Add("Account", data.Account); //分账接收方账号
Fields.Add("Name", data.Name); //分账个人接收方姓名
Fields.Add("RelationType", data.RelationType); //与分账方的关系类型
Fields.Add("CustomRelation", data.CustomRelation); //自定义的分账关系
Fields.Add("TransactionId", data.TransactionId); //微信订单号
Fields.Add("OutOrderNo", data.OutOrderNo); //商户分账单号
Fields.Add("Amount", data.Amount); //分账金额
Fields.Add("Description", data.Description); //分账描述
Fields.Add("UnfreezeUnsplit", data.UnfreezeUnsplit); //是否解冻剩余未分资金

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProfitReceiveRecord", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"ProfitReceiveRecord","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除分账记录信息

        /// <summary>
        /// 删除分账记录信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ProfitReceiveRecord","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProfitReceiveRecord", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ProfitReceiveRecord","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProfitReceiveRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ProfitReceiveRecord","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProfitReceiveRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Sort("ProfitReceiveRecord", Sort, Id);
            
            AddSysLog(Id.ToString(), "ProfitReceiveRecord", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.ProfitReceiveRecord.Add(new ProfitReceiveRecord()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "ProfitReceiveRecord", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(ProfitReceiveRecord data, string TypeSelect, string RelationTypeSelect, string StateSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
Fields.Add("SubMchid", "1"); //子商户号
Fields.Add("AppId", "1"); //应用ID
Fields.Add("SubAppId", "1"); //子商户应用ID
Fields.Add("Account", "1"); //分账接收方账号
Fields.Add("TransactionId", "1"); //微信订单号
Fields.Add("OutOrderNo", "1"); //商户分账单号
Fields.Add("OrderId", "1"); //微信分账单号


            string condition = " and Status>-1";
            //分账接收方类型
if (!string.IsNullOrEmpty(TypeSelect))
{
condition += " and Type=" + TypeSelect;
}
//与分账方的关系类型
if (!string.IsNullOrEmpty(RelationTypeSelect))
{
condition += " and RelationType=" + RelationTypeSelect;
}
//分账单状态
if (!string.IsNullOrEmpty(StateSelect))
{
condition += " and State=" + StateSelect;
}


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ProfitReceiveRecord", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //分账接收方类型
string Type = dic["Type"].ToString();
if(Type == "MERCHANT_ID") dic["Type"] = "商户ID";
if(Type == "PERSONAL_OPENID") dic["Type"] = "个人openid";
if(Type == "PERSONAL_SUB_OPENID") dic["Type"] = "个人sub_openid";
if(Type == "") dic["Type"] = "";
//与分账方的关系类型
string RelationType = dic["RelationType"].ToString();
if(RelationType == "SERVICE_PROVIDER") dic["RelationType"] = "服务商";
if(RelationType == "STORE") dic["RelationType"] = "门店";
if(RelationType == "STAFF") dic["RelationType"] = "员工";
if(RelationType == "STORE_OWNER") dic["RelationType"] = "店主";
if(RelationType == "PARTNER") dic["RelationType"] = "合作伙伴";
if(RelationType == "HEADQUARTER") dic["RelationType"] = "总部";
if(RelationType == "BRAND") dic["RelationType"] = "品牌方";
if(RelationType == "DISTRIBUTOR") dic["RelationType"] = "分销商";
if(RelationType == "USER") dic["RelationType"] = "用户";
if(RelationType == "SUPPLIER") dic["RelationType"] = "供应商";
if(RelationType == "CUSTOM") dic["RelationType"] = "自定义";
if(RelationType == "") dic["RelationType"] = "";
dic["UnfreezeUnsplitName"] = dic["UnfreezeUnsplit"].ToString() == "1" ? "是" : "否";
//分账单状态
string State = dic["State"].ToString();
if(State == "PROCESSING") dic["State"] = "处理中";
if(State == "FINISHED") dic["State"] = "分账完成";
if(State == "") dic["State"] = "";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "ProfitReceiveRecord", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
